#ifndef plugin_defsH
#define plugin_defsH

#include <windows.h>
#include "cl_struct.h"

typedef int (*TLENFUNCTION)(WPARAM,LPARAM);
#define CallProtoFunction(a, b, c, d, ret) {ProtocolFunctionDef fn;InitializeStruct(fn);fn.ProtocolID=a;fn.FunctionName=b;fn.wParam=(WPARAM)c;fn.lParam=(LPARAM)d;ret=CallService(TLEN_PROTOCOL_CALL_FUNCTION,(WPARAM)&fn,NULL);};
//-----------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------
//Dotyczy wersji
//-----------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------

#define TLEN_APPLICATION_MESSAGE_HOOK   "Tlen/ApplicationMessageHook"

//Zwraca wersje tlenu
#define TLEN_GET_TLEN_VERSION           "Tlen/GetTlenVersion"

//Zwraca wersje protokolu
#define TLEN_GET_TLEN_PROTOCOL_VERSION  "Tlen/GetTlenProtocolVersion"

//Zwraca wersje protokolu danego uzytkownika
#define TLEN_GET_USER_PROTOCOL_VERSION  "Tlen/GetUserProtocolVersion"
/// WPARAM adres na strukture ProtocolInfoDef
/// LPARAM NULL
typedef struct {

  int structSize;

  char *UserName;
  char *ID;
  TLENFUNCTION UserProtocolVersionCallback;

} ProtocolInfoDef;

// zwraca katalog instalacyjny tlenu, w wParam nalezy przekazac wskaznik do zaalokowanej tablicy znakow
// w lParam dlugosc tej tablicy,
// funkcja zwraca zero jesli operacja sie powiodla, wartosc mniejsza od zera oznacza blad podczas pobierania
// katalogu instalacyjnego, wartosc wieksza od zera oznacza, ze wielkosc przekazanej tablicy byla za mala
// i funkcja zwraca potrzebna wielkosc tablicy (lacznie ze znakiem zerowym na koncu tablicy)
#define TLEN_GET_EXE_PATH           "Tlen/GetExePath"

//------------------------------------------------------------------------------------------------
//przy logowaniu/wylogowaniu profilu:

typedef struct {

 int structSize;

 char *Login;
 char *Password;

 char *ProfileName;
 char *ProfileDirPath;

} ProfileInfoDef;


//------------------------------------------------------------------------------------------------
//struktura dla dodawania kontaktw telefonicznych tlenofonu

#define TLENOFON_ADD_PHONE				"Tlenofon/AddPhone"

typedef struct {

 int structSize;

 ContactDef *ct;
 char *phonenumber;
 char *description;

} TlenofonAddPhoneDef;

//------------------------------------------------------------------------------------------------
//funkcja wolana po dwukliku na kontakcie telefonicznym/ikonce telefonicznej przy kontakcie
//jesli zwroci 1, to znaczy, ze tlenofon obsluzyl dwuklik i tlen ma nic nie robic wiecej
//WPARAM ContactDef *

#define TLENOFON_PHONE_DBLCLK				"Tlenofon/Phone/DblClk"

//Wywoanie rozmowym tlenofonowej z shella
//WPARAM - char * (numer telefoniczny)
#define TLENOFON_SHELL_CALL                             "Tlenofon/ShellCall"

#endif

